/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest{}

// AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest struct for AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest
type AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest struct {
	CallbackUrl *string                                                                                            `json:"callbackUrl,omitempty"`
	Config      []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner `json:"config,omitempty"`
}

// NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest instantiates a new AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest {
	this := AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest{}
	return &this
}

// NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequestWithDefaults instantiates a new AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequestWithDefaults() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest {
	this := AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest{}
	return &this
}

// GetCallbackUrl returns the CallbackUrl field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) GetCallbackUrl() string {
	if o == nil || IsNil(o.CallbackUrl) {
		var ret string
		return ret
	}
	return *o.CallbackUrl
}

// GetCallbackUrlOk returns a tuple with the CallbackUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) GetCallbackUrlOk() (*string, bool) {
	if o == nil || IsNil(o.CallbackUrl) {
		return nil, false
	}
	return o.CallbackUrl, true
}

// HasCallbackUrl returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) HasCallbackUrl() bool {
	if o != nil && !IsNil(o.CallbackUrl) {
		return true
	}

	return false
}

// SetCallbackUrl gets a reference to the given string and assigns it to the CallbackUrl field.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) SetCallbackUrl(v string) {
	o.CallbackUrl = &v
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) GetConfig() []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner {
	if o == nil || IsNil(o.Config) {
		var ret []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner
		return ret
	}
	return o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) GetConfigOk() ([]AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner and assigns it to the Config field.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) SetConfig(v []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) {
	o.Config = v
}

func (o AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CallbackUrl) {
		toSerialize["callbackUrl"] = o.CallbackUrl
	}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest struct {
	value *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest
	isSet bool
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) Get() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest {
	return v.value
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) Set(val *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest(val *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest {
	return &NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthProcessCallbackRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
